precision mediump float;

#if defined(TEXTURE)
	uniform sampler2D u_diffuseTexture;
	varying vec2 v_UV;
#else
	uniform vec4 u_diffuseColor;
#endif

#if defined(VERTEX_COLOR)
	varying vec3 v_color;
#endif

const vec3 fogcolor = vec3(1.0, 1.0, 1.0);
const float density = 0.000025;

void main()
{
	#if defined(TEXTURE)
		vec4 col = texture2D(u_diffuseTexture, v_UV);
	#else
		vec4 col = u_diffuseColor;
	#endif

	#if defined(VERTEX_COLOR)
		col *= vec4(v_color, 1.0);
	#endif

	float z = gl_FragCoord.z / gl_FragCoord.w;
	float fog = clamp(exp(-density * z * z), 0.01, 1.0);	
	gl_FragColor = vec4(mix(fogcolor, col.rgb, fog), col.a);
}